%define kernel_version         3.10.0-327.49.58.50.x86_64
%define patch_version          1.0
%define patch_release          1

%define patch_package_name
%define patch_name
%define patch_fullname

%define patch_summary  FusionOS kernel hotpatch
%define patch_desc     The hotpatch can take effect without reboot your system.

%define patch_klp_requires ""
%define patch_mod_requires ""
%define system_livepatch_dir /sys/kernel/livepatch

Name:       %{patch_fullname}
Version:    %{patch_version}
Release:    %{patch_release}
Summary:    %{patch_summary}
Group:      System Environment/Base
License:    GPL

Source0:    %{name}-%{version}.tar.bz2

Prefix:     /usr/lib/modules/%{kernel_version}
Vendor:     xFusion

BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires:  bash

%if %{?patch_requires:1}0
Requires:   %{patch_requires}
%endif

%if %{?patch_obsoletes:1}0
Obsoletes:   %{patch_obsoletes}
%endif

%define product_path    %{prefix}/kernel-hotpatch/%{patch_name}

%description
%{patch_desc}

%prep
%setup -q -n %{name}-%{version}

%build

%install
[ ${RPM_BUILD_ROOT} != "/" ] && %__rm -rf ${RPM_BUILD_ROOT}

%__mkdir_p %{buildroot}/%{product_path}

# Install kernel patch file
%__cp -a %{patch_package_name} %{buildroot}/%{product_path}/
%__cp -a klp-info %{buildroot}/%{product_path}/
%__cp -a klp-changes %{buildroot}/%{product_path}/

%pre
current_kernel_version=`uname -r`
if [ ${current_kernel_version} != %{kernel_version} ]; then
    echo "The patch requires kernel version \"%{kernel_version}\" which doesn't match the current running kernel version \"${current_kernel_version}\"."
    exit 1
fi

patch_mod_reqs="%{patch_mod_requires}"
for mod in ${patch_mod_reqs[@]}
do
    if [ "${mod}" != "vmlinux" ]; then
        echo "Check base module: ${mod}..."
        count=`lsmod | awk '{print $1}' | grep -w ${mod} | wc -l`
        if [ ${count} -eq 0 ]; then
            echo "${mod} is not installed!"
            exit 2
        fi
    fi
done

patch_klp_reqs="%{patch_klp_requires}"
for klp_require in ${patch_klp_reqs[@]}
do
    echo "Check requirement: ${klp_require}..."
    is_require_installed=0
    is_require_enabled=0
    for installed_klp in `ls -d %{system_livepatch_dir}/* 2>/dev/null`
    do
        if [ "%{system_livepatch_dir}/${klp_require}" = "${installed_klp}" ]; then
            is_require_installed=1
            klp_state=`cat ${installed_klp}/enabled 2>/dev/null`
            if [ ! -z "${klp_state}" ] && [ ${klp_state} -eq 1 ]; then
                is_require_enabled=1
            fi
            break
        fi
    done

    if [ ${is_require_installed} -eq 0 ]; then
        echo "\"${klp_require}\" is not installed!"
        exit 2
    fi

    if [ ${is_require_enabled} -eq 0 ]; then
        echo "\"${klp_require}\" is not enabled!"
        exit 2
    fi
done

%post
livepatch -l %{product_path}/%{patch_package_name}
livepatch -a %{patch_package_name}

%preun
if [ "$1" = "0" ]; then
    if [ -e "/sys/kernel/livepatch/%{patch_name}" ]; then
        livepatch -r %{patch_name}
    fi
fi

%postun
if [ "$1" = "0" ]; then
    if [ -e %{product_path}/%{patch_package_name} ]; then
        %__rm -rf %{product_path}/%{patch_package_name}
    fi
fi

%clean
[ ${RPM_BUILD_ROOT} != "/" ] && %__rm -rf ${RPM_BUILD_ROOT}

%files
%defattr(0640,root,root,-)
%attr(0750,root,root) %dir %{product_path}

%{product_path}/*

%changelog
* Mon Jan 24 2022 Wu Qiong<wuqiong@xfusion.com> - 1.0-1
- Type:requirement
- CVE:
- DESC:init
